﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Buddy.Wildstar;
using Buddy.Common;
using Buddy.Wildstar.Engine;
using Buddy.Wildstar.Game;
namespace CombatBot
{
    public class CombatBot : CoroutinePulsable, IBot
    {
        private bool _pulseMe = true;

        public void OnInitialize()
        {
        }

        public void OnStart()
        {
            GameEngine.BotPulsator.RegisterForPulse(GameManager.Lua.Events);
            GameEngine.BotPulsator.RegisterForPulse(GameEngine.CurrentRoutine);
            SpellManager.SetSpellCastingBehavior(SpellCastingBehavior.Normal);
        }

        public void OnStop()
        {
            if (GameEngine.CurrentRoutine != null)
			{
				GameEngine.BotPulsator.UnregisterForPulse(GameEngine.CurrentRoutine);
			}
			GameEngine.BotPulsator.UnregisterForPulse(GameManager.Lua.Events);
        }

        public void OnUninitialize()
        {
        }

        public override bool CanBePulsed
        {
            get {
                return _pulseMe;
            }
        }

        public override void Pulse()
        {
            
        }

        public string Author
        {
            get { return "Paulmuadip"; }
        }

        public string Name
        {
            get { return "CombatBot"; }
        }

        public string Version
        {
            get { return "1.0.0"; }
        }

        public override Task CoroutineImplementation()
        {
            throw new NotImplementedException();
        }

        public bool Equals(IBot other)
        {
            throw new NotImplementedException();
        }

    }
}
